<?php
require 'vendor/autoload.php';
require 'config.php';
use Aws\S3\S3Client;
use Aws\Exception\AwsException;
$s3Config = [
    'version' => 'latest',
    'region' => 'node-sgp-1',
    'endpoint' => S3_ENDPOINT,
    'use_path_style_endpoint' => true,
    'use_aws_shared_config_files' => false,
    'credentials' => [
        'key' => S3_KEY,
        'secret' => S3_SECRET,
    ],
    'bucket' => S3_BUCKET,
];
$s3 = new S3Client($s3Config);
$response = [
    'success' => false,
    'urls' => [], 
    'errors' => []
];

if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_FILES['file'])) {
    foreach ($_FILES['file']['tmp_name'] as $key => $tmpFilePath) {
        $originalFileName = basename($_FILES['file']['name'][$key]);
        $extension = pathinfo($originalFileName, PATHINFO_EXTENSION);
        $md5Hash = md5_file($tmpFilePath);
        $fileKey = 'servuploads/' . $md5Hash . '.' . $extension;
        try {
            $result = $s3->putObject([
                'Bucket' => S3_BUCKET,
                'Key' => $fileKey,
                'SourceFile' => $tmpFilePath,
                'ACL' => 'public-read',
            ]);
            $response['success'] = true;
            $response['urls'][] = $result['ObjectURL'];

        } catch (AwsException $e) {
            $response['errors'][] = [
                'file' => $originalFileName,
                'message' => $e->getMessage(),
            ];
        }
    }
}

header('Content-Type: application/json');
echo json_encode($response);
?>
